<?php
 /**
 * @package com_jlfilemaneger
 * @author Arkadiy Sedelnikov(a.sedelmikov@gmail.com)
 * @version 1.0
 * @copyright (C) 2014 by JoomLine (http://www.joomline.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');

include_once JPATH_ROOT . '/administrator/components/com_jlfilemanager/classes/elFinderConnector.class.php';
include_once JPATH_ROOT . '/administrator/components/com_jlfilemanager/classes/elFinder.class.php';
include_once JPATH_ROOT . '/administrator/components/com_jlfilemanager/classes/elFinderVolumeDriver.class.php';
include_once JPATH_ROOT . '/administrator/components/com_jlfilemanager/classes/elFinderVolumeLocalFileSystem.class.php';

// Required for MySQL storage connector
// include_once dirname(__FILE__).DIRECTORY_SEPARATOR.'elFinderVolumeMySQL.class.php';
// Required for FTP connector support
// include_once dirname(__FILE__).DIRECTORY_SEPARATOR.'elFinderVolumeFTP.class.php';

class jlfilemanagerControllerConnector extends JControllerForm
{
    public function run()
    {
        $app = JFactory::getApplication();
        $userToken = $app->getUserState('com_jlfilemanager.token', '');
        $token = $app->input->getString('token', '');

        if($userToken != $token){
            echo json_encode(array('error' => 'Token fail', 'debug' => 'userToken = '.$userToken.', token = '.$token));
            $app->close();
        }

        $config	= JComponentHelper::getParams('com_jlfilemanager');

        $url = trim($config->get('root_dir', 'images'), '/').'/';
        $path = JPATH_ROOT . '/' . $url;
        $url = JUri::root() . $url;

        $roots = array(
            'driver' => 'LocalFileSystem', // driver for accessing file system (REQUIRED)
            'path' => $path, // path to files (REQUIRED)
            'URL' => $url, // URL to files (REQUIRED)
            'accessControl' => 'access', // disable and hide dot starting files (OPTIONAL)
        );

        if($config->get('check_mime', 1)){
            $uploadAllow = $config->get('upload_mime', 'image/jpeg,image/gif,image/png,image/bmp,application/x-shockwave-flash,application/msword,application/excel,application/pdf,application/powerpoint,text/plain,application/x-zip,application/zip');
            $roots['uploadAllow'] = explode(',', str_replace(' ', '', $uploadAllow));
        }

        $roots['uploadMaxSize'] = $config->get('upload_limit', '500K');

        $opts = array(
            // 'debug' => true,
            'roots' => array(
                $roots
            )
        );
        // run elFinder
        $connector = new elFinderConnector(new elFinder($opts));
        $connector->run();
    }
}
